(include "QobiScheme")

(define (read-cpu-time port)
 (let ((line (read-line port)))
  (+ (string->number
      (list->string (but-last (string->list (field-ref line 0)))))
     (string->number
      (list->string (but-last (string->list (field-ref line 1))))))))

(define (cpu-time->string cpu-time)
 (number->string-of-length-and-precision cpu-time 6 3))

(call-with-input-file "run.text"
 (lambda (port)
  (let* ((g++-compile1 (read-cpu-time port))
	 (g++-compile2 (read-cpu-time port))
	 (g++-compile3 (read-cpu-time port))
	 (g++-compile4 (read-cpu-time port))
	 (g++-run1a (read-cpu-time port))
	 (g++-run1b (read-cpu-time port))
	 (g++-run1c (read-cpu-time port))
	 (g++-run2a (read-cpu-time port))
	 (g++-run2b (read-cpu-time port))
	 (g++-run2c (read-cpu-time port))
	 (g++-run3a (read-cpu-time port))
	 (g++-run3b (read-cpu-time port))
	 (g++-run3c (read-cpu-time port))
	 (g++-run4a (read-cpu-time port))
	 (g++-run4b (read-cpu-time port))
	 (g++-run4c (read-cpu-time port))
	 (g++-run1 (min g++-run1a g++-run1b g++-run1c))
	 (g++-run2 (min g++-run2a g++-run2b g++-run2c))
	 (g++-run3 (min g++-run3a g++-run3b g++-run3c))
	 (g++-run4 (min g++-run4a g++-run4b g++-run4c))
	 (ocaml-compile1 (read-cpu-time port))
	 (ocaml-compile2 (read-cpu-time port))
	 (ocaml-compile3 (read-cpu-time port))
	 (ocaml-compile4 (read-cpu-time port))
	 (ocaml-run1a (read-cpu-time port))
	 (ocaml-run1b (read-cpu-time port))
	 (ocaml-run1c (read-cpu-time port))
	 (ocaml-run2a (read-cpu-time port))
	 (ocaml-run2b (read-cpu-time port))
	 (ocaml-run2c (read-cpu-time port))
	 (ocaml-run3a (read-cpu-time port))
	 (ocaml-run3b (read-cpu-time port))
	 (ocaml-run3c (read-cpu-time port))
	 (ocaml-run4a (read-cpu-time port))
	 (ocaml-run4b (read-cpu-time port))
	 (ocaml-run4c (read-cpu-time port))
	 (ocaml-run1 (min ocaml-run1a ocaml-run1b ocaml-run1c))
	 (ocaml-run2 (min ocaml-run2a ocaml-run2b ocaml-run2c))
	 (ocaml-run3 (min ocaml-run3a ocaml-run3b ocaml-run3c))
	 (ocaml-run4 (min ocaml-run4a ocaml-run4b ocaml-run4c))
	 (mlton-compile1 (read-cpu-time port))
	 (mlton-compile2 (read-cpu-time port))
	 (mlton-compile3 (read-cpu-time port))
	 (mlton-compile4 (read-cpu-time port))
	 (mlton-run1a (read-cpu-time port))
	 (mlton-run1b (read-cpu-time port))
	 (mlton-run1c (read-cpu-time port))
	 (mlton-run2a (read-cpu-time port))
	 (mlton-run2b (read-cpu-time port))
	 (mlton-run2c (read-cpu-time port))
	 (mlton-run3a (read-cpu-time port))
	 (mlton-run3b (read-cpu-time port))
	 (mlton-run3c (read-cpu-time port))
	 (mlton-run4a (read-cpu-time port))
	 (mlton-run4b (read-cpu-time port))
	 (mlton-run4c (read-cpu-time port))
	 (mlton-run1 (min mlton-run1a mlton-run1b mlton-run1c))
	 (mlton-run2 (min mlton-run2a mlton-run2b mlton-run2c))
	 (mlton-run3 (min mlton-run3a mlton-run3b mlton-run3c))
	 (mlton-run4 (min mlton-run4a mlton-run4b mlton-run4c))
	 (stalin-compile1 (read-cpu-time port))
	 (stalin-compile2 (read-cpu-time port))
	 (stalin-compile3 (read-cpu-time port))
	 (stalin-compile4 (read-cpu-time port))
	 (stalin-run1a (read-cpu-time port))
	 (stalin-run1b (read-cpu-time port))
	 (stalin-run1c (read-cpu-time port))
	 (stalin-run2a (read-cpu-time port))
	 (stalin-run2b (read-cpu-time port))
	 (stalin-run2c (read-cpu-time port))
	 (stalin-run3a (read-cpu-time port))
	 (stalin-run3b (read-cpu-time port))
	 (stalin-run3c (read-cpu-time port))
	 (stalin-run4a (read-cpu-time port))
	 (stalin-run4b (read-cpu-time port))
	 (stalin-run4c (read-cpu-time port))
	 (stalin-run1 (min stalin-run1a stalin-run1b stalin-run1c))
	 (stalin-run2 (min stalin-run2a stalin-run2b stalin-run2c))
	 (stalin-run3 (min stalin-run3a stalin-run3b stalin-run3c))
	 (stalin-run4 (min stalin-run4a stalin-run4b stalin-run4c)))
   (format #t "Compile times~%")
   (format #t "         ray1   ray2   ray3   ray4~%")
   (format #t "g++    ~a ~a ~a ~a~%"
	   (cpu-time->string g++-compile1)
	   (cpu-time->string g++-compile2)
	   (cpu-time->string g++-compile3)
	   (cpu-time->string g++-compile4))
   (format #t "OCaml  ~a ~a ~a ~a~%"
	   (cpu-time->string ocaml-compile1)
	   (cpu-time->string ocaml-compile2)
	   (cpu-time->string ocaml-compile3)
	   (cpu-time->string ocaml-compile4))
   (format #t "MLton  ~a ~a ~a ~a~%"
	   (cpu-time->string mlton-compile1)
	   (cpu-time->string mlton-compile2)
	   (cpu-time->string mlton-compile3)
	   (cpu-time->string mlton-compile4))
   (format #t "Stalin ~a ~a ~a ~a~%"
	   (cpu-time->string stalin-compile1)
	   (cpu-time->string stalin-compile2)
	   (cpu-time->string stalin-compile3)
	   (cpu-time->string stalin-compile4))
   (newline)
   (format #t "Run times (best of three)~%")
   (format #t "         ray1   ray2   ray3   ray4~%")
   (format #t "g++    ~a ~a ~a ~a~%"
	   (cpu-time->string g++-run1)
	   (cpu-time->string g++-run2)
	   (cpu-time->string g++-run3)
	   (cpu-time->string g++-run4))
   (format #t "OCaml  ~a ~a ~a ~a~%"
	   (cpu-time->string ocaml-run1)
	   (cpu-time->string ocaml-run2)
	   (cpu-time->string ocaml-run3)
	   (cpu-time->string ocaml-run4))
   (format #t "MLton  ~a ~a ~a ~a~%"
	   (cpu-time->string mlton-run1)
	   (cpu-time->string mlton-run2)
	   (cpu-time->string mlton-run3)
	   (cpu-time->string mlton-run4))
   (format #t "Stalin ~a ~a ~a ~a~%"
	   (cpu-time->string stalin-run1)
	   (cpu-time->string stalin-run2)
	   (cpu-time->string stalin-run3)
	   (cpu-time->string stalin-run4))
   (newline)
   (format #t "Run times relative to Stalin~%")
   (format #t "         ray1   ray2   ray3   ray4~%")
   (format #t "g++    ~a ~a ~a ~a~%"
	   (cpu-time->string (/ g++-run1 stalin-run1))
	   (cpu-time->string (/ g++-run2 stalin-run2))
	   (cpu-time->string (/ g++-run3 stalin-run3))
	   (cpu-time->string (/ g++-run4 stalin-run4)))
   (format #t "OCaml  ~a ~a ~a ~a~%"
	   (cpu-time->string (/ ocaml-run1 stalin-run1))
	   (cpu-time->string (/ ocaml-run2 stalin-run2))
	   (cpu-time->string (/ ocaml-run3 stalin-run3))
	   (cpu-time->string (/ ocaml-run4 stalin-run4)))
   (format #t "MLton  ~a ~a ~a ~a~%"
	   (cpu-time->string (/ mlton-run1 stalin-run1))
	   (cpu-time->string (/ mlton-run2 stalin-run2))
	   (cpu-time->string (/ mlton-run3 stalin-run3))
	   (cpu-time->string (/ mlton-run4 stalin-run4)))
   (newline)
   (format
    #t "On average, Stalin is ~s% faster than g++, ~s% faster than OCaml,~%"
    (inexact->exact
     (truncate (* (- (/ (+ (/ g++-run1 stalin-run1)
			   (/ g++-run2 stalin-run2)
			   (/ g++-run3 stalin-run3)
			   (/ g++-run4 stalin-run4))
			4)
		     1.0)
		  100.0)))
    (inexact->exact
     (truncate (* (- (/ (+ (/ ocaml-run1 stalin-run1)
			   (/ ocaml-run2 stalin-run2)
			   (/ ocaml-run3 stalin-run3)
			   (/ ocaml-run4 stalin-run4))
			4)
		     1.0)
		  100.0))))
   (format #t "and ~s% faster than MLton.~%"
	   (inexact->exact
	    (truncate (* (- (/ (+ (/ mlton-run1 stalin-run1)
				  (/ mlton-run2 stalin-run2)
				  (/ mlton-run3 stalin-run3)
				  (/ mlton-run4 stalin-run4))
			       4)
			    1.0)
			 100.0)))))))
